extra-1.8.1: Extra functions I use.

Safe Haskell | Safe-Inferred
Language | Haskell2010

Data.IORef.Extra

Description

This module extends Data.IORef with operations forcing the value written to the IORef. Some of these functions are available in later versions of GHC, but not all.

Synopsis

- module Data.IORef
- writeIORef' :: IORef a -> a -> IO ()
- atomicWriteIORef' :: IORef a -> a -> IO ()
- atomicModifyIORef_ :: IORef a -> (a -> a) -> IO ()
- atomicModifyIORef'_ :: IORef a -> (a -> a) -> IO ()

# Documentation

module Data.IORef

writeIORef' :: IORef a -> a -> IO () Source #

Evaluates the value before calling `writeIORef`.

atomicWriteIORef' :: IORef a -> a -> IO () Source #

Evaluates the value before calling `atomicWriteIORef`.

atomicModifyIORef_ :: IORef a -> (a -> a) -> IO () Source #

Variant of `atomicModifyIORef` which ignores the return value

atomicModifyIORef'_ :: IORef a -> (a -> a) -> IO () Source #

Variant of `atomicModifyIORef'` which ignores the return value